osg::VertexProgram Class Reference

`#include <VertexProgram>`

Inheritance diagram for osg::VertexProgram:

## Public Types

typedef std::map< GLuint, Vec4 > | LocalParamList
typedef std::map< GLenum, Matrix > | MatrixList
Public Types inherited from osg::StateAttribute
enum | Values { OFF = 0x0 , ON = 0x1 , OVERRIDE = 0x2 , PROTECTED = 0x4 , INHERIT = 0x8 }

enum

Type {
TEXTURE , POLYGONMODE , POLYGONOFFSET , MATERIAL ,
ALPHAFUNC , ANTIALIAS , COLORTABLE , CULLFACE ,
FOG , FRONTFACE , LIGHT , POINT ,
LINEWIDTH , LINESTIPPLE , POLYGONSTIPPLE , SHADEMODEL ,
TEXENV , TEXENVFILTER , TEXGEN , TEXMAT ,
LIGHTMODEL , BLENDFUNC , BLENDEQUATION , LOGICOP ,
STENCIL , COLORMASK , DEPTH , VIEWPORT ,
SCISSOR , BLENDCOLOR , MULTISAMPLE , CLIPPLANE ,
COLORMATRIX , VERTEXPROGRAM , FRAGMENTPROGRAM , POINTSPRITE ,
PROGRAM , CLAMPCOLOR , HINT , SAMPLEMASKI ,
PRIMITIVERESTARTINDEX , CLIPCONTROL , VALIDATOR , VIEWMATRIXEXTRACTOR ,
OSGNV_PARAMETER_BLOCK , OSGNVEXT_TEXTURE_SHADER , OSGNVEXT_VERTEX_PROGRAM , OSGNVEXT_REGISTER_COMBINERS ,
OSGNVCG_PROGRAM , OSGNVSLANG_PROGRAM , OSGNVPARSE_PROGRAM_PARSER , UNIFORMBUFFERBINDING ,
TRANSFORMFEEDBACKBUFFERBINDING , ATOMICCOUNTERBUFFERBINDING , PATCH_PARAMETER , FRAME_BUFFER_OBJECT ,
VERTEX_ATTRIB_DIVISOR , SHADERSTORAGEBUFFERBINDING , INDIRECTDRAWBUFFERBINDING , VIEWPORTINDEXED ,
DEPTHRANGEINDEXED , SCISSORINDEXED , BINDIMAGETEXTURE , SAMPLER ,
CAPABILITY = 100
}

typedef GLenum | GLMode
typedef unsigned int | GLModeValue
typedef unsigned int | OverrideValue
typedef std::pair< Type, unsigned int > | TypeMemberPair
typedef std::vector< StateSet * > | ParentList
typedef osg::StateAttributeCallback | Callback
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| VertexProgram ()
| VertexProgram (const VertexProgram &vp, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_StateAttribute (osg, VertexProgram, VERTEXPROGRAM)
virtual int | compare (const osg::StateAttribute &sa) const
virtual bool | getModeUsage (StateAttribute::ModeUsage &usage) const
GLuint & | getVertexProgramID (unsigned int contextID) const
void | setVertexProgram (const char *program)
void | setVertexProgram (const std::string &program)
const std::string & | getVertexProgram () const
void | setProgramLocalParameter (const GLuint index, const Vec4 &p)
void | setLocalParameters (const LocalParamList &lpl)
LocalParamList & | getLocalParameters ()
const LocalParamList & | getLocalParameters () const
void | setMatrix (const GLenum mode, const Matrix &matrix)
void | setMatrices (const MatrixList &matrices)
MatrixList & | getMatrices ()
const MatrixList & | getMatrices () const
void | dirtyVertexProgramObject ()
virtual void | apply (State &state) const
virtual void | compileGLObjects (State &state) const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (State *state=0) const
Public Member Functions inherited from osg::StateAttribute
| StateAttribute ()
| StateAttribute (const StateAttribute &sa, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Texture * | asTexture ()
virtual const Texture * | asTexture () const
virtual Type | getType () const =0
virtual unsigned int | getMember () const
TypeMemberPair | getTypeMemberPair () const
virtual bool | isTextureAttribute () const
bool | operator< (const StateAttribute &rhs) const
bool | operator== (const StateAttribute &rhs) const
bool | operator!= (const StateAttribute &rhs) const
const ParentList & | getParents () const
StateSet * | getParent (unsigned int i)
const StateSet * | getParent (unsigned int i) const
unsigned int | getNumParents () const
void | setShaderComponent (ShaderComponent *sc)
ShaderComponent * | getShaderComponent ()
const ShaderComponent * | getShaderComponent () const
virtual bool | checkValidityOfAssociatedModes (osg::State &) const
void | setUpdateCallback (StateAttributeCallback *uc)
StateAttributeCallback * | getUpdateCallback ()
const StateAttributeCallback * | getUpdateCallback () const
void | setEventCallback (StateAttributeCallback *ec)
StateAttributeCallback * | getEventCallback ()
const StateAttributeCallback * | getEventCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef buffered_value< GLuint > | VertexProgramIDList

## Protected Member Functions

virtual | ~VertexProgram ()
Protected Member Functions inherited from osg::StateAttribute
virtual | ~StateAttribute ()
void | addParent (osg::StateSet *object)
void | removeParent (osg::StateSet *object)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

VertexProgramIDList | _vertexProgramIDList
std::string | _vertexProgram
LocalParamList | _programLocalParameters
MatrixList | _matrixList
Protected Attributes inherited from osg::StateAttribute
ParentList | _parents
ref_ptr< ShaderComponent > | _shaderComponent
ref_ptr< StateAttributeCallback > | _updateCallback
ref_ptr< StateAttributeCallback > | _eventCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

VertexProgram - encapsulates the OpenGL ARB vertex program state.

## Member Typedef Documentation

## LocalParamList

typedef std::map<GLuint,Vec4> osg::VertexProgram::LocalParamList

## MatrixList

typedef std::map<GLenum,Matrix> osg::VertexProgram::MatrixList

## VertexProgramIDList

typedef buffered_value<GLuint> osg::VertexProgram::VertexProgramIDList

protected

## Constructor & Destructor Documentation

## VertexProgram() [1/2]

osg::VertexProgram::VertexProgram | ( |  | ) |

Referenced by compare(), META_StateAttribute(), and VertexProgram().

## VertexProgram() [2/2]

osg::VertexProgram::VertexProgram | ( | const VertexProgram & | vp,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References osg::CopyOp::SHALLOW_COPY, and VertexProgram().

## ~VertexProgram()

virtual osg::VertexProgram::~VertexProgram | ( |  | ) |

protected virtual

## Member Function Documentation

## apply()

virtual void osg::VertexProgram::apply | ( | State & |  | ) | const

virtual

apply the OpenGL state attributes. The render info for the current OpenGL context is passed in to allow the StateAttribute to obtain details on the the current context and state.

Reimplemented from osg::StateAttribute.

Referenced by compileGLObjects().

## compare()

virtual int osg::VertexProgram::compare | ( | const osg::StateAttribute & | sa | ) | const

inline virtual

Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.

Implements osg::StateAttribute.

References _vertexProgram, COMPARE_StateAttribute_Parameter, COMPARE_StateAttribute_Types, and VertexProgram().

## compileGLObjects()

virtual void osg::VertexProgram::compileGLObjects | ( | State & |  | ) | const

inline virtual

Default to nothing to compile - all state is applied immediately.

Reimplemented from osg::StateAttribute.

References apply().

## dirtyVertexProgramObject()

void osg::VertexProgram::dirtyVertexProgramObject | ( |  | ) |

Force a recompile on next apply() of associated OpenGL vertex program objects.

Referenced by setVertexProgram(), and setVertexProgram().

## getLocalParameters() [1/2]

LocalParamList & osg::VertexProgram::getLocalParameters | ( |  | ) |

inline

Get list of Program Parameters

References _programLocalParameters.

## getLocalParameters() [2/2]

const LocalParamList & osg::VertexProgram::getLocalParameters | ( |  | ) | const

inline

Get const list of Program Parameters

References _programLocalParameters.

## getMatrices() [1/2]

MatrixList & osg::VertexProgram::getMatrices | ( |  | ) |

inline

Get list of Matrices

References _matrixList.

## getMatrices() [2/2]

const MatrixList & osg::VertexProgram::getMatrices | ( |  | ) | const

inline

Get list of Matrices

References _matrixList.

## getModeUsage()

virtual bool osg::VertexProgram::getModeUsage | ( | StateAttribute::ModeUsage & |  | ) | const

inline virtual

Return the modes associated with this StateAttribute.

Reimplemented from osg::StateAttribute.

References GL_VERTEX_PROGRAM_ARB, and osg::StateAttribute::ModeUsage::usesMode().

## getVertexProgram()

const std::string & osg::VertexProgram::getVertexProgram | ( |  | ) | const

inline

Get the vertex program.

References _vertexProgram.

## getVertexProgramID()

GLuint & osg::VertexProgram::getVertexProgramID | ( | unsigned int | contextID | ) | const

inline

Get the handle to the vertex program ID for the current context.

References _vertexProgramIDList.

## META_StateAttribute()

osg::VertexProgram::META_StateAttribute | ( | osg | ,
|  | VertexProgram | ,
|  | VERTEXPROGRAM | )

References osg::StateAttribute::VERTEXPROGRAM, and VertexProgram().

## releaseGLObjects()

virtual void osg::VertexProgram::releaseGLObjects | ( | State * | state = 0 | ) | const

virtual

Release any OpenGL objects in specified graphics context if State object is passed, otherwise release OpenGL objects for all graphics contexts if State object pointer is NULL.

Reimplemented from osg::StateAttribute.

## resizeGLObjectBuffers()

virtual void osg::VertexProgram::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::StateAttribute.

## setLocalParameters()

void osg::VertexProgram::setLocalParameters | ( | const LocalParamList & | lpl | ) |

inline

Set list of Program Parameters

References _programLocalParameters.

## setMatrices()

void osg::VertexProgram::setMatrices | ( | const MatrixList & | matrices | ) |

inline

Set list of Matrices

References _matrixList.

## setMatrix()

void osg::VertexProgram::setMatrix | ( | const GLenum | mode,
|  | const Matrix & | matrix )

inline

Matrix

References _matrixList.

## setProgramLocalParameter()

void osg::VertexProgram::setProgramLocalParameter | ( | const GLuint | index,
|  | const Vec4 & | p )

inline

Set Program Parameters

References _programLocalParameters.

## setVertexProgram() [1/2]

void osg::VertexProgram::setVertexProgram | ( | const char * | program | ) |

inline

Set the vertex program using a C style string.

References _vertexProgram, and dirtyVertexProgramObject().

## setVertexProgram() [2/2]

void osg::VertexProgram::setVertexProgram | ( | const std::string & | program | ) |

inline

Set the vertex program using C++ style string.

References _vertexProgram, and dirtyVertexProgramObject().

## Member Data Documentation

## _matrixList

MatrixList osg::VertexProgram::_matrixList

protected

Referenced by getMatrices(), getMatrices(), setMatrices(), and setMatrix().

## _programLocalParameters

LocalParamList osg::VertexProgram::_programLocalParameters

protected

Referenced by getLocalParameters(), getLocalParameters(), setLocalParameters(), and setProgramLocalParameter().

## _vertexProgram

std::string osg::VertexProgram::_vertexProgram

protected

Referenced by compare(), getVertexProgram(), setVertexProgram(), and setVertexProgram().

## _vertexProgramIDList

VertexProgramIDList osg::VertexProgram::_vertexProgramIDList

mutable protected

Referenced by getVertexProgramID().

The documentation for this class was generated from the following file:

- VertexProgram